structure Check :>
sig

    exception TypeError of string

    (* Given a context gamma and expression e, 
       return tau if there is a tau such that gamma |- e : tau, or
       raise TypeError otherwise *)
    val check : Syntax.exp -> Syntax.typ
        
end  = 
struct

    open Syntax
    
    type context = (name * typ) list

    (* if you want, you can always 
       raise TypeError "" 
       but if you put in nice error messages 
       then it might help when you're programming in FPC later in the assignment *)
    exception TypeError of string

    (*  Given a patter p and a type t, 
        check whether p : t binding Delta for some context Delta, and if so return Delta.
        
        Otherwise, raise TypeError
    *)
    fun checkPat(p : pat, t : typ) : context = raise Fail "unimplemented"

    (* Given a context gamma and expression e, 
       return tau if there is a tau such that gamma |- e : tau, or
       raise TypeError otherwise *)
    fun checkOpen (g : context, e : exp) : typ = raise Fail "unimplemented"

    (* Given an expression e, 
       return tau if there is a tau such that empty |- e : tau,
       or raise TypeError if e is not well-typed in the empty context *)
    fun check e = checkOpen ([], e)
	
end
